import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Font;

/**
 * Counter that displays the score / a number.
 * 
 * @author Folkert van Verseveld
 * @version 0.1.0
 */
public class Counter extends Actor
{
    private int value = 0;
    private String text;
    private int stringLength;
    public static int target = 0;

    public Counter()
    {
        this("");
    }

    public Counter(String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 16;

        setImage(new GreenfootImage(stringLength, 24));
        GreenfootImage image = getImage();
        Font font = image.getFont();
        image.setFont(font.deriveFont(24.0F));  // use larger font
        
        updateImage();
    }
    
    public void act() {
        if(value < target) {
            value = Ball.score;
            updateImage();
        }
        else if(value > target) {
            value = Ball.score;
            updateImage();
        }
    }

    public static void add(int score)
    {
        target += score;
    }

    public void subtract(int score)
    {
        target -= score;
    }

    public int getValue()
    {
        return value;
    }
    
    public int getTarget()
    {
        return target;
    }

    /**
     * Make the image
     */
    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 18);
    }
    
    /**
     * reset - Resets the values of counte
     */
    public void reset()
    {
        value = 0;
        target = 0;
        updateImage();
    }
}
